<?php
/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Created on 15 sept. 07 by AEL Sarl for
 * 
 * osCommerce, Open Source E-Commerce Solutions
 * http://www.oscommerce.com
 *
 * Copyright (c) 2003 osCommerce
 *
 * Released under the GNU General Public License
 * 
 */

/**
 * Recursively explore categories, fetches all products in them and inserts them
 * @param	string	$parent_id		parent category identifier
 * @param	string	$parent_name	parent category name
 */
function explore_categories($parent_id, $parent_name) {
	$level_query = tep_db_query("SELECT c.categories_id, cd.categories_name" .
	                            " FROM " . TABLE_CATEGORIES . " c JOIN " . TABLE_CATEGORIES_DESCRIPTION . " cd" .
	                            " ON c.categories_id = cd.categories_id" .
								" AND c.parent_id = " . $parent_id .
							    " AND language_id = " . OPENSI_LANGUAGE);
    while ($level_row = tep_db_fetch_array($level_query)) {
    	fetch_articles($level_row['categories_id'],
    	                $level_row['categories_name'],
    	                $parent_name);
    	explore_categories($level_row['categories_id'], $parent_name);
    } 
}

/**
 * Fetch all articles
 * Added a where condition for bundled_products
 * @param	string		$categories_id		a category identifier
 * @param	string		$categories_name	a category name
 * @param	string		$parent_name		the category parent name
 */
function fetch_articles($categories_id, $categories_name, $parent_name) {
	$products_query = tep_db_query("SELECT p.products_id, pd.products_name, p.products_price, p.products_tax_class_id," .
	                               " p.products_quantity, pd.products_description, IFNULL(m.manufacturers_name, '') AS manufacturers_name," .
                                   " p.products_weight, p.products_image" .
	                               " FROM " . TABLE_PRODUCTS . " p" . 
	                               " JOIN " . TABLE_PRODUCTS_DESCRIPTION . " pd" .
	                               " ON p.products_id = pd.products_id" .
	                               " JOIN " .TABLE_PRODUCTS_TO_CATEGORIES . " pc" .
	                               " ON p.products_id = pc.products_id" .
	                               " LEFT JOIN " . TABLE_MANUFACTURERS . " m" .
	                               " ON p.manufacturers_id = m.manufacturers_id" .
	                               " WHERE pd.language_id = " . OPENSI_LANGUAGE .
	                               " AND pc.categories_id = " . $categories_id);
    while($product = tep_db_fetch_array($products_query)) {
    	$product['family'] = $parent_name;
    	$product['sub_family'] = $categories_name;
    	insert_product_temp($product);
    }
}

/**
 * Create temporary products storage
 */
function create_products_temp() {
	
	# first create the correspondences table
	tep_db_query("CREATE TABLE IF NOT EXISTS FICHE_ARTICLE_TEMP (" .
                 "Article_Id VARCHAR(40) NOT NULL PRIMARY KEY, " .
                 "Designation VARCHAR(100), " .
                 "Description TEXT, " .
                 "Marque VARCHAR(100), " .
                 "Famille VARCHAR(40), " .
                 "Sous_Famille VARCHAR(40), " .
                 "Prix_Vente DECIMAL(14,4) UNSIGNED, " .
                 "Taux_TVA DECIMAL(7,4), " .
                 "Stock INT(11), " . 
                 "Poids DECIMAL(10,2), " .
                 "Nom_Image VARCHAR(64))");
    tep_db_query("DELETE FROM FICHE_ARTICLE_TEMP");
    # insert products_id which do not belong to any category
    $orphaned_products_query = tep_db_query("SELECT p.products_id, pd.products_name, p.products_price, p.products_tax_class_id," .
	                                        " p.products_quantity, pd.products_description, IFNULL(m.manufacturers_name, '') AS manufacturers_name," .
                                            " p.products_weight, p.products_image" .
	                                        " FROM " . TABLE_PRODUCTS . " p" .
	                                        " LEFT JOIN " . TABLE_PRODUCTS_TO_CATEGORIES . " pc" .
	                                        " ON p.products_id = pc.products_id" .
	                                        " LEFT JOIN " . TABLE_MANUFACTURERS . " m" .
	                                        " ON p.manufacturers_id = m.manufacturers_id" .
	                                        " JOIN " . TABLE_PRODUCTS_DESCRIPTION . " pd" .
	                                        " ON p.products_id = pd.products_id" .
	                                        " WHERE pc.products_id IS NULL" .
	                                        " AND pd.language_id = " . OPENSI_LANGUAGE);
    while($product = tep_db_fetch_array($orphaned_products_query)) {
    	$product['family'] = '';
    	$product['sub_family'] = '';
    	insert_product_temp($product);
    }
    
    # recursively search for products in categories
    # search first for top level categories
    $top_level_query = tep_db_query("SELECT c.categories_id, categories_name FROM " .
                                    TABLE_CATEGORIES . " c, " . TABLE_CATEGORIES_DESCRIPTION . " cd" .
									" WHERE c.categories_id = cd.categories_id" .
								    " AND parent_id = ''" .
								    " AND language_id = " . OPENSI_LANGUAGE);
    while ($top_level_row = tep_db_fetch_array($top_level_query)) {
    	fetch_articles($top_level_row['categories_id'], '', $top_level_row['categories_name']);
    	explore_categories($top_level_row['categories_id'], $top_level_row['categories_name']);
    }                                    
                        
} 
 
/** 
 * Insert temporary products
 * @param	array	$article	array of product values
 */
function insert_product_temp($article) {
	tep_db_query("INSERT INTO FICHE_ARTICLE_TEMP VALUES ('" .
    	             build_article_id($article['products_id']) . "', '" .
    	             tep_db_input($article['products_name']) . "', '" .
    	             tep_db_input($article['products_description']) . "', '" .
    	             tep_db_input($article['manufacturers_name']) . "', '" .
    	             tep_db_input($article['family']) . "', '" .
    	             tep_db_input($article['sub_family']) . "', " .
    	             $article['products_price'] . ", " .
    	             opensi_get_tax_rate($article['products_tax_class_id']) . ", " .
    	             $article['products_quantity'] . ", " .
    	             $article['products_weight'] . ", '" . 
    	             tep_db_input($article['products_image']) . "')" .
    	             " ON DUPLICATE KEY UPDATE Famille = VALUES(Famille), Sous_Famille = VALUES(Sous_Famille)");
}

/**
 * Search for the manufacturer id knowing its name
 * @param 	string 	$manufacturer_name		the name of the searched manufacturer
 * @return	int		The manufacturer id, or 0 if not found
 */
function get_manufacturer_id_by_name($manufacturer_name) {
	$man_query = tep_db_query("SELECT manufacturers_id FROM " .
	                          TABLE_MANUFACTURERS .
	                          " WHERE manufacturers_name = '" . tep_db_input($manufacturer_name) . "'");
	if ($man_query && tep_db_num_rows($man_query) > 0) {
		$man = tep_db_fetch_array($man_query);
		return $man['manufacturers_id'];
	}	
	return 0;                          
}

/**
 * Search for the category id knowing its name and the parent identifier
 * @param 	string  $category_name	 a named category
 * @param 	int		$parent_id		parent identifier
 * @return	int		the category identifier 
 */
function get_category_id_by_name($category_name, $parent_id=0) {
	$cats_query = tep_db_query("SELECT c.categories_id FROM " . 
							   TABLE_CATEGORIES . " c, " . TABLE_CATEGORIES_DESCRIPTION . " cd" .
	                          " WHERE cd.categories_name = '" . tep_db_input($category_name) . "'" .
	                          " AND c.categories_id = cd.categories_id" .
	                          " AND cd.language_id = " . OPENSI_LANGUAGE .
	                          " AND c.parent_id = " . $parent_id);
	$cats = tep_db_fetch_array($cats_query);
	return (tep_not_null($cats) ? $cats['categories_id'] : 0);
}

/**
 * Get the parents of a category
 * @param	int		$category_id	a category identifier
 * @return	array	an array of parents'ids
 */
function get_category_parent_id($category_id) {
	$retval = array();
	$parents = tep_db_query("SELECT parent_id" .
	                        " FROM " . TABLE_CATEGORIES .
	                        " WHERE categories_id = " . $category_id);
	while ($parent = tep_db_fetch_array($parents))
		$retval[] = $parent['parent_id'];
	return $retval;	                     
}

/**
 * Search for matching categories id, given the category id
 * and some sub-categories ids.
 * The category is always a top level category, one of those having a
 * parent id equals to 0
 * 
 * @param	 int		$category_id		a top level category id
 * @param	 array  	$subcategory_ids	array of categories id
 * @return	 int  		the matching sub-category id
 */
function get_matching_categories_id($category_id, $subcategory_ids) {
	
	foreach ($subcategory_ids as $subcategory_id) {
		$parents = get_category_parent_id($subcategory_id);
		foreach ($parents as $parent_id) {
			if ($parent_id == $category_id)
				return $subcategory_id;
		}
		$recursive = get_matching_categories_id($category_id, $parents);
		if ($recursive != 0)
			return $subcategory_id;
	}
	return 0;
}

/**
 * Creates a manufacturer entry in the database, if needed
 * @param	string	$manufacturer_name	a manufacturer name
 * @return	int		the newly created, or the existing manufacturer identifier
 */
function create_manufacturer($manufacturer_name) {
	
	if ($manufacturer_name == '')
		return 0;	
	if (($manufacturer_id = get_manufacturer_id_by_name($manufacturer_name)) != 0)
		return $manufacturer_id;
		
	tep_db_query("INSERT INTO " . TABLE_MANUFACTURERS . 
                 " (manufacturers_name, date_added) VALUES ('" .
                 tep_db_input($manufacturer_name) . "', NOW())");
    return tep_db_insert_id();
}

/**
 * Insert a category in the database
 * @param	string	$category_name	the category_name
 * @param	int		$parent_id		the parent identifier of this new category
 * @return	int		the newly created category identifier
 */
function insert_category($category_name, $parent_id) {
	tep_db_query("INSERT INTO " . TABLE_CATEGORIES . 
                 " (parent_id, date_added) VALUES (" .
                 $parent_id . ", NOW())");
    $new_id = tep_db_insert_id();
    tep_db_query("INSERT INTO " . TABLE_CATEGORIES_DESCRIPTION .
                 "(categories_id, language_id, categories_name) VALUES (" .
                 $new_id . ", " . OPENSI_LANGUAGE . ", '" .
                 tep_db_input($category_name) . "')");
    return $new_id;
}

/**
 * Creates a couple of category/sub-category entries in the database, if needed
 * @param	string	$category_name		a category name
 * @param	string	$subcategory_name	a sub category name, a child of the first parameter
 * @return	int		the newly created, or the existing sub category identifier
 */
function create_category($category_name, $subcategory_name) {
	
	// The product can be out of the category tree
	if ($category_name == '')
		return 0;
	
	/* the category is always a top level category, so it should exist
	 * If it does not, the category, and its sub-category are created
	 */
	$category_id = get_category_id_by_name($category_name, 0);
	if ($category_id == 0) {
		$category_id = insert_category($category_name, 0);
		if ($subcategory_name != '')
			$category_id = insert_category($subcategory_name, $category_id);
		return $category_id;
	}
	
	/*
	 * The top level category exists
	 * Search for a sub category named $subcategory_name,
	 * and create it if necessary
	 */
	if ($subcategory_name == '')
		return $category_id;
	/*
	 * Assume now we have valids category/sub-category names
	 */
	 
	// convert the subcategory name into an array of id's
	$subcats_query = tep_db_query("SELECT categories_id FROM " . 
	                              TABLE_CATEGORIES_DESCRIPTION .
	                              " WHERE categories_name = '" . tep_db_input($subcategory_name) . 
                                  "' AND language_id = " . OPENSI_LANGUAGE);
	// search parents
	$subcategory_ids = array();
	while ($subcats = tep_db_fetch_array($subcats_query))
		$subcategory_ids[] = $subcats['categories_id'];
	
	$matching_subcategory_id = get_matching_categories_id($category_id, $subcategory_ids);
	if ($matching_subcategory_id == 0) {
		$category_id = insert_category($subcategory_name, $category_id);
		return $category_id;
	} else
		return $matching_subcategory_id;
		
}

/**
 * Get the counter value knowing the operation key
 *
 * @param	string	$operation	operation name
 * @return	int	a counter value
 */
function get_web_manager_op_counter($operation) {
	$counter_query = tep_db_query("SELECT Web_Manager_Op_Counter FROM WEB_MANAGER_OPERATIONS" .
		                          " WHERE Web_Manager_Op = '" . $operation . "'");
	if (!$counter_query)
		return 0;
	$counter = tep_db_fetch_array($counter_query);
	return ($counter ? $counter['Web_Manager_Op_Counter'] : 0);
}

?>
