<?php
/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Created on 1 août 07 by AEL Sarl for
 * 
 * osCommerce, Open Source E-Commerce Solutions
 * http://www.oscommerce.com
 *
 * Copyright (c) 2003 osCommerce
 *
 * Released under the GNU General Public License
 * 
 */

require_once("includes/common.php");
require_once("includes/init_VL.php");
require("includes/classes/OpensiProduct.php");
require("includes/classes/OpensiImage.php");

/*
 * Format array of
 * key : a constant name, see includes/<language>.php
 * value : an array of values : OpenSI order status name (N, C, E, M) and validation id expected
 *                              in uploadCommandes.java for this name
 */
/*OPENSI_ORDERS_STATUS = array(
							"OPENSI_ORDERS_STATUS_NEW" => array("N", 1),
                            "OPENSI_ORDERS_STATUS_PROCESSING" => array("C", 2),
                            "OPENSI_ORDERS_STATUS_SHIPPED" => array("E", 3),
 							"OPENSI_ORDERS_STATUS_FAILURE" => array("M", 0));*/

/**
 * A very basic connection test
 * @return	array	an OpenSI report
 */
function testsInitiaux() {
	global $web_link;

	$code = $web_link ? CONNEXION_BASE_OK : CONNEXION_BASE_KO;
	tep_db_close();
	return array(array(array($code, WEB_SITE, '')));
}
	
/**
 * Prepare the web site:
 *  - create a table for performed operations
 *  - finds the correspondences between products and categorie
 *  - finds the families and sub-families
 * Added a where condition for bundled_products
 */
function preparerSite() {
	
	// create a table for operations
	tep_db_query("CREATE TABLE IF NOT EXISTS WEB_MANAGER_OPERATIONS (" .
				 "Web_Manager_Op VARCHAR(64) NOT NULL PRIMARY KEY," .
				 " Web_Manager_Last_Modified DATETIME NOT NULL," .
				 " Web_Manager_Op_Counter INT(11) NOT NULL DEFAULT 0)");
	
	// table for correspondences
	tep_db_query("CREATE TABLE IF NOT EXISTS PRODUCTS_TO_OPENSI (" .
	      	 	 "Products_Id INT(11)," .
	             " Opensi_Web_Id VARCHAR(64)," .
	             " PRIMARY KEY (Products_Id, Opensi_Web_Id))");
	// table for orders_status
	tep_db_query("CREATE TABLE IF NOT EXISTS OPENSI_ORDERS_STATUS (" .
				"Orders_Status_Id INT NOT NULL PRIMARY KEY," .
				" Opensi_Orders_Status_Id INT NOT NULL," .
				" Opensi_Orders_Status_Name CHAR(1))");
	tep_db_query("DELETE FROM OPENSI_ORDERS_STATUS");
	global $OPENSI_ORDERS_STATUS;
	
	foreach ($OPENSI_ORDERS_STATUS as $key => $array_values) {
		if (defined($key)) {
			$status_query = mysql_query("SELECT orders_status_id FROM " . TABLE_ORDERS_STATUS . 
					                    " WHERE orders_status_name = '" . constant($key) . "'" .
					                    " AND language_id = " . OPENSI_LANGUAGE);
			if(!mysql_num_rows($status_query))
				trigger_error("Clé OPENSI_STATUS définie (" . $key . ") sans correspondance en " . TABLE_ORDERS_STATUS,
				              E_USER_WARNING);
			while ($status = mysql_fetch_array($status_query, MYSQL_ASSOC)) {
				mysql_query("INSERT INTO OPENSI_ORDERS_STATUS VALUES (" .
				            $status["orders_status_id"] . ", " .
                            $array_values[1] . ", '" . 
                            $array_values[0] . "')");
			}
			
		}
	}
	// test de correspondance inverse
	$status_query = mysql_query(
						"SELECT os.orders_status_name" .
	                    " FROM " . TABLE_ORDERS_STATUS . " os LEFT JOIN OPENSI_ORDERS_STATUS oos" .
	                    " ON os.Orders_Status_Id = oos.Orders_Status_Id" .
	                    " WHERE language_id = " . OPENSI_LANGUAGE .
	                    " AND oos.Orders_Status_Id IS NULL");
	while ($status = mysql_fetch_array($status_query, MYSQL_ASSOC)) {
		trigger_error("orders_status name '" . $status['orders_status_name'] . "' défini dans " . TABLE_ORDERS_STATUS .
		              " et sans correspondance dans le tableau des OPENSI_STATUS_*",
		              E_USER_WARNING);
	}   
	             
	tep_db_close();
    return array(array(array(AUTRE_OK, WEB_SITE)));                               
}

/*
 * Upload the articles
 * Returns the report and an array of uploaded articles
 */
 
function uploadArticlesExistant() {
	
	$articles_existant = array();
	$final_report = array();
	
	$max_products_id = get_web_manager_op_counter('uploadArticlesExistant');
	
	if ($max_products_id == 0) {
		// create the temporary storage for categories
		create_products_temp();
	}
	
	$products_query = tep_db_query(
                        "SELECT Article_Id, Designation, Stock, Famille, Sous_Famille," .
                        " 1 AS En_Ligne, Description, Marque, '' AS Collection, Poids, IFNULL(Nom_Image, '') AS Nom_Image," .
                        " Taux_TVA, '' AS Couleur, '' AS Taille, Prix_Vente" . 
                        " FROM FICHE_ARTICLE_TEMP" .
                        " ORDER BY Article_Id " .
                        " LIMIT 0," . (OPENSI_FETCH_LIMIT + 1));
                        
    $has_more = (tep_db_num_rows($products_query) > OPENSI_FETCH_LIMIT);
    
    while ($product = tep_db_fetch_row($products_query)) {
    	// last row means that we have more row to fetch
    	if (count($articles_existant) == OPENSI_FETCH_LIMIT)
    		break;
    	
    	// push the various prices at value 0
    	array_push($product, 0.0, 0.0, 0.0, 0.0,
    	           calculate_included_tax_price($product[14], $product[11]), 0.0, 0.0, 0.0, 0.0,
    	           0.0, 0.0, 0.0);
    	$opensi_product = new OpensiProduct($product);
    	$prepared = $opensi_product->prepareUpload();
    	
    	if (is_array($prepared) && count($prepared) == 27)
    		$final_report[] = array(SELECT_OK, $opensi_product->name);
		else  {  		
    		$final_report[] = array(SELECT_K0, $opensi_product->name);
    		$prepared = array();
		}
		
		$articles_existant[] = $prepared;
    }
    
    // delete rows if ready to send
    foreach ($articles_existant as $record)
        	tep_db_query("DELETE FROM FICHE_ARTICLE_TEMP" .
        	             " WHERE Article_Id = '" . $record[0] . "'");
    
    // delete table if finished
    if (!$has_more) {
    	tep_db_query("DROP TABLE FICHE_ARTICLE_TEMP");
    	tep_db_query("INSERT INTO WEB_MANAGER_OPERATIONS VALUES".
                     " ('uploadArticlesExistant', NOW(), 0) ON DUPLICATE KEY UPDATE" .
                     " Web_Manager_Last_Modified = NOW()," .
				     " Web_Manager_Op_Counter = 0");
    } else
    	tep_db_query("INSERT INTO WEB_MANAGER_OPERATIONS VALUES".
                     " ('uploadArticlesExistant', NOW(), " . extract_product_id($product[0]) . ") ON DUPLICATE KEY UPDATE" .
					 " Web_Manager_Last_Modified = NOW(), " .
				     " Web_Manager_Op_Counter = VALUES(Web_Manager_Op_Counter)");
    
    tep_db_close();
    return array($final_report, array($articles_existant, $has_more));
}


/*
 * Fetches an article image name, encode it as
 * base64 string and returns it as array
 * array[0] is image name
 * array[1] is image content as Base64 string
 * array[2] is image size
 */
function uploadImage($article_id) {
	
	$article_query = tep_db_query("SELECT products_image" .
	                              " FROM " . TABLE_PRODUCTS .
	                              " WHERE products_id = " . extract_product_id($article_id));
	$img_array = tep_db_fetch_array($article_query);
	tep_db_close();
	$img = new OpensiImage($img_array['products_image']);
	return array(array(AUTRE_OK), $img->prepareUpload());
}

/**
 * Fetches a category image
 * @param	string	$famille	a category name
 * @return	array	an OpenSI report
 */
function uploadImageFamille($famille) {
	$categories_image_query = tep_db_query("SELECT categories_image" .
	                                       " FROM " . TABLE_CATEGORIES . " c, " . TABLE_CATEGORIES_DESCRIPTION . " cd" .
	                                       " WHERE c.categories_id = cd.categories_id" . 
	                                       " AND language_id = " . OPENSI_LANGUAGE . 
	                                       " AND cd.categories_name = '" . tep_db_input($famille) . "'");
	$img_array = tep_db_fetch_array($categories_image_query);
	tep_db_close();
	$img = new OpensiImage($img_array['categories_image']);
	
	return array(array(AUTRE_OK), $img->prepareUpload());
}

/**
 * Fetches a manufacturer image
 * @param	string	$marque	a manufacturer's name
 * @return	array	an OpenSI report
 */
function uploadImageMarque($marque) {
	$manufacturers_image_query = tep_db_query("SELECT manufacturers_image" .
	                                          " FROM " . TABLE_MANUFACTURERS .
	                                          " WHERE manufacturers_name = '" . tep_db_input($marque) . "'");
	$img_array = tep_db_fetch_array($manufacturers_image_query);
	tep_db_close();
	$img = new OpensiImage($img_array['manufacturers_image']);
	
	return array(array(AUTRE_OK), $img->prepareUpload());
}

/**
 * Fetches a subcategory image
 * Starts from the sub-category and search for the corresponding category
 * When found, returns the image
 * @param	string	$famille		a category name
 * @param   string	$sous_famille	a subcategory name	
 * @return	array	an OpenSI report
 */
function uploadImageSousFamille($famille, $sous_famille) {
	
	$more = true;
	$sub_category_name = $sous_famille;
	while ($more) {
		$categories_query = tep_db_query(
                                 "SELECT cd2.categories_name AS parent_name, c.categories_image" .
	                             " FROM " . TABLE_CATEGORIES . " c" . 
	                             " JOIN " . TABLE_CATEGORIES_DESCRIPTION . " cd" .
	                             " ON c.categories_id = cd.categories_id" .
	                             " JOIN " . TABLE_CATEGORIES_DESCRIPTION . " cd2" .
	                             " ON c.parent_id = cd2.categories_id" .
	                             " WHERE cd.language_id = " . OPENSI_LANGUAGE . 
	                             " AND cd2.language_id = " . OPENSI_LANGUAGE . 
	                             " AND cd.categories_name = '" . tep_db_input($sub_category_name) . "'");
		$categories = tep_db_fetch_array($categories_query);
		if (!tep_not_null($categories))
			$more = false;
		if ($categories['parent_name'] == $famille) { // found the category knowing the sub-category                             
			tep_db_close();
			$img = new OpensiImage($categories['categories_image']);
			return array(array(AUTRE_OK), $img->prepareUpload());
		} else {
			$sub_category_name = $categories['parent_name'];
		}
	}
	
	return array(array(AUTRE_K0), null);
}

?>
